/***************************************************************************\
 *                                     Math2HTML                            *
 *                                     ------------------------------------ *
 *                                     Copyright  1995 Janne Saarela/CERN  *
 \**************************************************************************/

/*
 * $Log$
 */

static char *rcsid = "$Revision$";

#include "node.h"

Node::Node ()
{
    m_pSubscript = m_pSupscript = NULL;
}

Node::~Node ()
{
    if (subscript())
	delete subscript();
    if (superscript())
	delete superscript();
}

void
Node::subscript (Node *pNode)
{
    m_pSubscript = pNode;
}

void
Node::superscript (Node *pNode)
{
    m_pSupscript = pNode;
}

Node *
Node::subscript (void)
{
    return m_pSubscript;
}

Node *
Node::superscript (void)
{
    return m_pSupscript;
}

void
Node::convert_html3 (void)
{
    if (subscript()) {
	strcat (pResult, "<sub>");
	subscript()->convert_html3();
	strcat (pResult, "</sub>");
    }
    if (superscript()) {
	strcat (pResult, "<sup>");
	superscript()->convert_html3();
	strcat (pResult, "</sup>");
    }
}

void
Node::convert_12083 (void)
{
    if (subscript()) {
	strcat (pResult, "<inf>");
	subscript()->convert_12083 ();
	strcat (pResult, "</inf>");
    }
    if (superscript()) {
	strcat (pResult, "<sup>");
	superscript()->convert_12083 ();
	strcat (pResult, "</sup>");
    }
}

void
Node::cleanup (void)
{
    // this delete will initiate the run of all destructors starting
    // from the furthest inherited class
    delete this;
}
