/***************************************************************************\
 *                                     Math2HTML                            *
 *                                     ------------------------------------ *
 *                                     Copyright  1994 Janne Saarela/CERN  *
 \**************************************************************************/

/*
 * $Log$
 */

#ifndef INCL_NODE_H
#define INCL_NODE_H 1

#include <stream.h>

extern "C" {
#include <stdlib.h>
#include <string.h>
#include <assert.h>
};
#include "type.h"
#include "rtti.h"
#ifdef TRUE
#undef TRUE
#endif
#ifdef FALSE
#undef FALSE
#endif

typedef enum { FALSE = 0, TRUE } Boolean;

#define BOOLEAN(expr) ((expr) ? TRUE : FALSE)
#define NOT(expr) ((expr) ? FALSE : TRUE)

class Node : public RTTI
{
public:
    DECLARE_RTTI (Node);

    Node ();
    virtual ~Node ();

    void		subscript (Node *);
    void		superscript (Node *);

    Node		*subscript (void);
    Node		*superscript (void);
    
    virtual void	convert_html3 (void);
    virtual void	convert_12083 (void);
    void		cleanup (void);

private:
    Node *m_pSubscript;
    Node *m_pSupscript;

};

#endif // INCL_NODE_H
